import sys
sys.path.append('modules')
from DateTime import *

#rule: time->importance       : spring -> seasonal activity
#mind: time2num[a.time]==time : spring -> 3,4,5
#      importance comparison  : 


time_info={'always': [range(1,13),'seasonal'],
           'spring': [[3,4,5],'seasonal'],
           'summer': [[6,7,8],'seasonal'],
           'autumn': [[9,10,11],'seasonal'],
           'winter': [[12,1,2],'seasonal'],
           'morning': [[8], 'daily'],
           'midday': [[12], 'daily'],
           'evening': [[20], 'daily'],
           'night': [[21,22,23,24,0,1,2,3,4,5,6,7], 'daily']}

importance2num={None: 0,
                'seasonal': 1,
                'daily': 2}

def time2type(t):
    return time_info[t][1]

time2importance=time2type

def cmp_importance(a,b):
    return importance2num[a]-importance2num[b]

#time functions for world
class world_time:
    time=Date(1421)
    stepsize=RelativeDateTime(hours=+1)
    def __call__(self):
        return self.time
    def __str__(self):
        s="time="+str(self.time)
        return s
    def __cmp__(self,other):
        if time2type(other)=='seasonal':
            if self.time.month in time_info[other][0]:
                return 0
            else:
                return 1
        if time2type(other)=='daily':
            if self.time.hour in time_info[other][0]:
                return 0
            else:
                return 1
        return 1
    def step(self):
        self.time=self.time+self.stepsize
